package cn.wch.meshdemo.adapter

import android.view.LayoutInflater
import android.view.ViewGroup
import android.widget.TextView
import androidx.recyclerview.widget.RecyclerView
import cn.wch.meshdemo.databinding.ItemGrouplistBinding
import cn.wch.meshdemo.storage.GroupItem
import cn.wch.meshdemo.storage.NodeItem
import cn.wch.meshdemo.storage.StorageUtil
import java.util.*

class GroupListAdapter(val listener:OnClickListener):RecyclerView.Adapter<GroupListAdapter.MyViewHolder>(){

    private var groupList: MutableList<GroupItem>? = null

    class MyViewHolder(binding: ItemGrouplistBinding) : RecyclerView.ViewHolder(binding.root) {
        var netAddress: TextView =binding.tvGroupAddress
        var name: TextView =binding.tvGroupName
        var deviceCount: TextView =binding.tvGroupDeviceCount
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): MyViewHolder {
        val inflate = ItemGrouplistBinding.inflate(LayoutInflater.from(parent.context), parent, false)
        return MyViewHolder(inflate)
    }

    override fun onBindViewHolder(holder: MyViewHolder, position: Int) {
        groupList?.let {
            val groupItem = it[position]
            holder.name.text = groupItem.name
            holder.netAddress.text = String.format(Locale.getDefault(),"Address:0x%04X",groupItem.address)
            holder.deviceCount.text = String.format(Locale.getDefault(),"%d Devices",groupItem.nodeAddressItem.size ?: 0)

            holder.itemView.setOnClickListener {
                listener.onClick(groupItem.address,groupItem.name)
            }
            holder.itemView.setOnLongClickListener {
                listener.onLongClick(groupItem.address,groupItem.name)
                true
            }
        }
    }

    override fun getItemCount(): Int {
        return groupList?.size ?: 0
    }

    public fun loadAllGroups(items:MutableList<GroupItem>?){
        groupList=items
        notifyDataSetChanged()
    }

    interface OnClickListener{
        fun onClick(groupAddress:Int?,name:String?)
        fun onLongClick(groupAddress:Int?,name:String?)

    }
}