package cn.wch.meshdemo.base

import android.content.Context
import android.net.Uri
import cn.wch.meshdemo.core.NodeViewModelKt
import cn.wch.meshdemo.dialog.InputShareFileInfoDialog
import cn.wch.meshdemo.ota.ShareFileResolver
import cn.wch.meshdemo.utils.LogTool

abstract class NodeMainActivity:NodeBaseActivity() {



    //接受分享文件
    protected fun checkShareFile() {
        //获得资源URI
        val intent = intent ?: return
        val uri = intent.data ?: return
        LogTool.d("we receive share file: $uri")
        val lastPathSegment = uri.lastPathSegment ?: return

        if (lastPathSegment != null && !lastPathSegment.endsWith(".bin") && !lastPathSegment.endsWith(".BIN")
            && !lastPathSegment.endsWith(".hex") && !lastPathSegment.endsWith(".HEX")) {
            showToast("只接收bin或者hex格式的文件")
            return
        }
        showShareFileDialog(lastPathSegment, uri)
    }

    protected fun showShareFileDialog(filename: String, uri: Uri) {
        val dialog: InputShareFileInfoDialog = InputShareFileInfoDialog.newInstance(filename)
        dialog.setCancelable(false)
        dialog.setListener {
            saveShareFileToPrivateFolder(
                this,
                uri,
                it!!
            )
        }
        dialog.show(supportFragmentManager, InputShareFileInfoDialog::class.java.getName())
    }

    private fun saveShareFileToPrivateFolder(context: Context, uri: Uri, newName:String){

        NodeViewModelKt.model.rxjavaExecute(this,"保存文件",{
            ShareFileResolver.uriToFile(context,uri,newName)
        },{},{showToast(it.message)},{showToast("保存升级文件成功")})
    }
}