package cn.wch.meshdemo.core;

import androidx.annotation.NonNull;
import androidx.lifecycle.LifecycleOwner;
import androidx.lifecycle.MutableLiveData;
import androidx.lifecycle.Observer;

public class MyLiveData<T> extends MutableLiveData<T> {

    private boolean shouldSupportStick=false;

    MyLiveData(boolean supportStick){
        super();
        this.shouldSupportStick=supportStick;
    }

    boolean hasChangeValue=false;
    @Override
    public void observe(@NonNull LifecycleOwner owner, @NonNull Observer<? super T> observer) {

        super.observe(owner, new Observer<T>() {

            private boolean hasIntercept=false;
            @Override
            public void onChanged(T t) {
                if(shouldSupportStick){
                    observer.onChanged(t);
                }else {
                    if (hasIntercept || !hasChangeValue) {
                        observer.onChanged(t);
                    }
                    hasIntercept=true;
                }

            }
        });
    }

    @Override
    public void observeForever(@NonNull Observer<? super T> observer) {
        super.observeForever(new Observer<T>() {
            private boolean hasIntercept=false;

            @Override
            public void onChanged(T t) {

                if(shouldSupportStick){
                    observer.onChanged(t);
                }else {
                    if (hasIntercept || !hasChangeValue) {
                        observer.onChanged(t);
                    }
                    hasIntercept=true;
                }

            }
        });
    }

    @Override
    public void postValue(T value) {
        super.postValue(value);
        hasChangeValue=true;
    }

    @Override
    public void setValue(T value) {
        super.setValue(value);
        hasChangeValue=true;
    }


}
