package cn.wch.meshdemo.core

import android.os.Bundle
import androidx.lifecycle.LiveData
import androidx.lifecycle.MutableLiveData
import androidx.lifecycle.ViewModel
import cn.wch.meshdemo.constant.IntentConstant
import cn.wch.meshdemo.storage.GroupItem
import cn.wch.meshdemo.storage.GroupStorageUtil
import cn.wch.meshdemo.storage.NodeItem
import cn.wch.meshdemo.storage.StorageUtil

class NodeViewModel :ViewModel(){

    var nodeList:MutableLiveData<MutableList<NodeItem>> = MutableLiveData();
    var groupList:MutableLiveData<MutableList<GroupItem>> = MutableLiveData();

    var event:MutableLiveData<Event> = MutableLiveData();

    public fun refreshAllNodeState(){
        val all = StorageUtil.getAllNode().toMutableList()
        nodeList.postValue(all)
    }

    public fun refreshAllGroupState(){
        val all = GroupStorageUtil.getAllGroup().toMutableList()
        groupList.postValue(all)
    }

    public fun addNode(){
        event.postValue(Event(CustomEvent.EVENT_ADD_NODE,null))
    }

    public fun addGroup(name: String,address:Int){
        GroupStorageUtil.putGroup(GroupItem(name,address,mutableListOf()))
        refreshAllGroupState()
    }

    public fun addNodeToGroup(nodeAddress:Int,groupAddress:Int){
        GroupStorageUtil.addNodeToGroup(nodeAddress,groupAddress)
    }

    public fun toNodeDetail(netAddress: Int?, name: String?){
        netAddress?.let{
            val bundle = Bundle()
            bundle.putInt(IntentConstant.BUNDLE_NODE_ADDRESS,netAddress)
            bundle.putString(IntentConstant.BUNDLE_NODE_NAME,name)
            event.postValue(Event(CustomEvent.EVENT_TO_NODE_DETAIL,bundle))
        }
    }

    public fun forceDeleteNodeLocal(netAddress: Int?, name: String?){
        netAddress?.let{
            val bundle = Bundle()
            bundle.putInt(IntentConstant.BUNDLE_NODE_ADDRESS,netAddress)
            bundle.putString(IntentConstant.BUNDLE_NODE_NAME,name)
            event.postValue(Event(CustomEvent.EVENT_DELETRTE_NODE_LOCAL,bundle))
        }
    }

    public fun toGroupDetail(netAddress: Int?, name: String?){
        netAddress?.let{
            val bundle = Bundle()
            bundle.putInt(IntentConstant.BUNDLE_GROUP_ADDRESS,netAddress)
            bundle.putString(IntentConstant.BUNDLE_GROUP_NAME,name)
            event.postValue(Event(CustomEvent.EVENT_TO_GROUP_DETAIL,bundle))
        }
    }








}