package cn.wch.meshdemo.dialog

import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.ArrayAdapter
import cn.wch.meshdemo.R
import cn.wch.meshdemo.databinding.DialogAddNodeToGroupBinding
import cn.wch.meshdemo.storage.GroupStorageUtil
import cn.wch.meshdemo.utils.ToastUtil
import java.util.*

class AddNodeToGroupDialog:BaseDialogFragment() {

    var binding: DialogAddNodeToGroupBinding?=null
    var listener:OnSelectGroupListener?=null

    companion object{
        fun newInstance(): AddNodeToGroupDialog {
            val args = Bundle()
            val fragment = AddNodeToGroupDialog()
            fragment.arguments = args
            return fragment
        }
    }

    override fun onCreateView(
        inflater: LayoutInflater,
        container: ViewGroup?,
        savedInstanceState: Bundle?
    ): View? {
        binding=DialogAddNodeToGroupBinding.inflate(inflater)
        initWidget()
        return binding!!.root
    }

    override fun onDestroyView() {
        super.onDestroyView()
        binding=null
    }

    private fun initWidget(){
        val allGroup = GroupStorageUtil.getAllGroup()
        var s= mutableListOf<String>()
        allGroup.forEach {
            s.add(String.format(Locale.getDefault(),"%04X",it.address))
        }

        val arrayAdapter = ArrayAdapter<String>(requireContext(), R.layout.item_spinner,s)
        arrayAdapter.setDropDownViewResource(R.layout.item_spinner)
        binding!!.spGroup.adapter=arrayAdapter
        binding!!.spGroup.setSelection(0)

        binding!!.cancel.setOnClickListener {
            dismiss()
        }
        binding!!.confirm.setOnClickListener {
            check()
        }

    }

    private fun check(){
        if(binding!!.spGroup.selectedItem==null){
            showToast("Group为空")
            return
        }
        val s = binding!!.spGroup.selectedItem as String
        val toInt = s.toInt(16)
        listener?.onSelectGroup(toInt)
        dismiss()
    }

    fun setSelectGroupListener(listener:OnSelectGroupListener){
        this.listener=listener
    }

    public interface OnSelectGroupListener{
        fun onSelectGroup(address:Int)
    }

    fun showToast(message:String){
        ToastUtil.create(requireActivity(),message)
    }
}