package cn.wch.meshdemo.dialog

import android.bluetooth.BluetoothDevice
import android.os.Bundle
import android.view.*
import androidx.fragment.app.DialogFragment
import androidx.recyclerview.widget.DividerItemDecoration
import androidx.recyclerview.widget.LinearLayoutManager
import cn.wch.meshdemo.databinding.DialogDevicelistBinding

class DeviceListDialog():DialogFragment(){

    lateinit var binding:DialogDevicelistBinding
    var listener:OnClickListener?=null
    var adapter:DeviceListAdapter?=null

    companion object{
        fun newInstance(): DeviceListDialog {
            val args = Bundle()
            val fragment = DeviceListDialog()
            fragment.arguments = args
            return fragment
        }
    }

    override fun onCreateView(
        inflater: LayoutInflater,
        container: ViewGroup?,
        savedInstanceState: Bundle?
    ): View? {
        dialog!!.requestWindowFeature(Window.FEATURE_NO_TITLE)
        dialog!!.window!!.setLayout(
            WindowManager.LayoutParams.MATCH_PARENT,
            WindowManager.LayoutParams.WRAP_CONTENT
        )
        binding = DialogDevicelistBinding.inflate(inflater)
        init()
        return binding.root
    }

    override fun onResume() {
        super.onResume()
        dialog!!.window!!.setLayout(
            WindowManager.LayoutParams.MATCH_PARENT,
            WindowManager.LayoutParams.WRAP_CONTENT
        )
    }

    private fun init(){
        adapter = DeviceListAdapter(object : DeviceListAdapter.OnClickListener {
            override fun onClick(device: BluetoothDevice) {
                dismiss()
                listener?.onClick(device.address)
            }
        })
        binding.list.layoutManager=
            LinearLayoutManager(context, LinearLayoutManager.VERTICAL, false)
        binding.list.adapter=adapter
        val decoration = DividerItemDecoration(context, DividerItemDecoration.VERTICAL)
        binding.list.addItemDecoration(decoration)

        binding.cancel.setOnClickListener {
            dismiss()
            listener?.onCancel()
        }
    }

    fun setOnCLickListener(listener:OnClickListener){
        this.listener=listener
    }

    interface OnClickListener {
        fun onClick(mac: String?)
        fun onCancel()
    }

    fun update(device: BluetoothDevice?, rssi: Int?) {
        if(device!=null && rssi!=null){
            adapter?.update(device, rssi)
        }
    }
}