package cn.wch.meshdemo.dialog

import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import cn.wch.meshdemo.databinding.DialogInputKeyAndAddressBinding
import cn.wch.meshdemo.utils.ConvertUtil
import cn.wch.meshdemo.utils.ToastUtil

class InputKeyAndNetAddressDialog:BaseDialogFragment() {
    var binding:DialogInputKeyAndAddressBinding?=null
    var listener:OnKeyAndAddressListener?=null
    companion object{
        fun newInstance(): InputKeyAndNetAddressDialog {
            val args = Bundle()
            val fragment = InputKeyAndNetAddressDialog()
            fragment.arguments = args
            return fragment
        }
    }

    override fun onCreateRealView(
        inflater: LayoutInflater,
        container: ViewGroup?,
        savedInstanceState: Bundle?
    ): View {
        binding = DialogInputKeyAndAddressBinding.inflate(layoutInflater)
        init()
        return binding!!.root
    }

    fun init(){
        binding!!.cancel.setOnClickListener {
            dismiss()
        }
        binding!!.confirm.setOnClickListener {
            check()
        }
    }

    override fun onDestroyView() {
        super.onDestroyView()
        binding=null
    }

    fun check(){
        val key = binding!!.tvInputKey.text.toString()
        val address=binding!!.tvInputAddress.text.toString()
        if ("" == key) {
            showToast("密钥为空")
            return
        }
        if (key.length != 16) {
            showToast("密钥长度应该为16字节")
            return
        }

        if ("" == address) {
            showToast("地址为空")
            return
        }
        if (address.length != 4) {
            showToast("地址长度应该为2字节")
            return
        }
        try {
            val mKey=ConvertUtil.fromHexString2ByteArray(key)
            val mNetAddress = ConvertUtil.fromHexString2ByteArray(address)
            listener?.onResult(mKey,mNetAddress)
        } catch (e: Exception) {
        }


    }

    fun setKeyAndResultListener(listener:OnKeyAndAddressListener){
        this.listener=listener
    }

    interface OnKeyAndAddressListener{
        fun onResult(key:ByteArray,address:ByteArray)
    }

    private fun showToast(message: String) {
        ToastUtil.create(requireActivity(), message)
    }

}