package cn.wch.meshdemo.dialog

import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import cn.wch.meshdemo.databinding.DialogInputAddressBinding
import cn.wch.meshdemo.utils.ConvertUtil
import cn.wch.meshdemo.utils.ToastUtil

class InputNetAddressDialog:BaseDialogFragment() {

    var binding:DialogInputAddressBinding?=null
    var listener:OnAddressListener?=null

    companion object{
        fun newInstance(): InputNetAddressDialog {
            val args = Bundle()
            val fragment = InputNetAddressDialog()
            fragment.arguments = args
            return fragment
        }
    }

    override fun onCreateRealView(
        inflater: LayoutInflater,
        container: ViewGroup?,
        savedInstanceState: Bundle?
    ): View {
        binding= DialogInputAddressBinding.inflate(layoutInflater)
        init()
        return binding!!.root
    }

    fun init(){

        binding!!.confirm.setOnClickListener {
            check()
        }
        binding!!.cancel.setOnClickListener {
            dismiss()
        }
    }

    fun check(){
        val address = binding!!.tvInputAddress.text.toString()
        if ("" == address) {
            showToast("地址为空")
            return
        }
        if (address.length != 2) {
            showToast("地址长度为2字节")
            return
        }
        val netAddress = ConvertUtil.fromHexString2ByteArray(address)
        listener?.onAddress(netAddress)
        dismiss()
    }

    override fun onDestroyView() {
        super.onDestroyView()
        binding=null
    }

    fun setAddressListener(listener:OnAddressListener?){
        this.listener=listener
    }

    interface OnAddressListener{
        fun onAddress(address:ByteArray)
    }

    private fun showToast(message: String) {
        ToastUtil.create(requireActivity(), message)
    }
}