package cn.wch.meshdemo.fragment

import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.fragment.app.Fragment
import androidx.lifecycle.ViewModelProvider
import androidx.recyclerview.widget.DividerItemDecoration
import androidx.recyclerview.widget.LinearLayoutManager
import cn.wch.meshdemo.adapter.NodeListAdapter
import cn.wch.meshdemo.core.NodeViewModel
import cn.wch.meshdemo.databinding.FragmentNetworkBinding
import cn.wch.meshdemo.utils.LogTool

class NetworkFragment:Fragment() {

    var binding:FragmentNetworkBinding?=null
    var adapter: NodeListAdapter?=null

    override fun onCreateView(
        inflater: LayoutInflater,
        container: ViewGroup?,
        savedInstanceState: Bundle?
    ): View? {
        binding = FragmentNetworkBinding.inflate(inflater)
        initWidget()
        return binding!!.root
    }

    override fun onDestroyView() {
        super.onDestroyView()
        binding=null
        LogTool.d("NetworkFragment onDestroyView")
    }

    private fun initWidget(){
        val viewModel = ViewModelProvider(requireActivity()).get(NodeViewModel::class.java)

        adapter = NodeListAdapter(object : NodeListAdapter.OnClickListener{
            override fun onClick(netAddress: Int?, name: String?) {
                viewModel.toNodeDetail(netAddress, name)
            }

            override fun onLongClick(netAddress: Int?, name: String?) {

                viewModel.forceDeleteNodeLocal(netAddress,name)
            }
        })

        binding!!.rvNode.adapter=adapter
        binding!!.rvNode.layoutManager=
            LinearLayoutManager(context, LinearLayoutManager.VERTICAL, false)
        binding!!.rvNode.addItemDecoration(DividerItemDecoration(context, DividerItemDecoration.VERTICAL))

        binding!!.fab.setOnClickListener {
            viewModel.addNode()
        }
        //订阅事件
        viewModel.nodeList.observe(viewLifecycleOwner){
            adapter?.loadAllNodes(it)
        }
        //获取节点列表
        viewModel.refreshAllNodeState()
    }


}