package cn.wch.meshdemo.ota;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import java.io.File;
import java.util.ArrayList;

import cn.wch.meshdemo.R;


public class FileListAdapter extends RecyclerView.Adapter<FileListAdapter.MyViewHolder> {

    private ArrayList<File> list;
    private Context context;
    private OnClickListener listener;

    public FileListAdapter( Context context,ArrayList<File> list,OnClickListener listener) {
        this.list = list;
        this.context = context;
        this.listener=listener;
    }

    @NonNull
    @Override
    public MyViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        return new MyViewHolder(LayoutInflater.from(context).inflate(R.layout.dialog_filelist_item,parent,false));
    }

    @Override
    public void onBindViewHolder(@NonNull MyViewHolder holder, int position) {
        final File file = list.get(position);
        holder.name.setText(file.getName());
        holder.itemView.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if(listener!=null){
                    listener.onClick(file);
                }
            }
        });
    }

    @Override
    public int getItemCount() {
        if(list==null){
            return 0;
        }
        return list.size();
    }

    public static class MyViewHolder extends RecyclerView.ViewHolder{
        TextView name;
        public MyViewHolder(@NonNull View itemView) {
            super(itemView);
            name=itemView.findViewById(R.id.file);
        }
    }

    public interface OnClickListener{
        void onClick(File file);
    }
}
