package cn.wch.meshdemo.utils

import cn.wch.meshdemo.exception.CustomException
import java.util.*

object ConvertUtil {
    fun fromHexString2ByteArray(hex:String):ByteArray{
        if(!hex.matches(Regex("([0-9|a-f|A-F]{2})+"))){
            throw CustomException("invalid hex string")
        }
        val len = hex.length / 2
        var temp=ByteArray(len){0}
        for (i in 0 until len step 1){
            val substring = hex.substring(i*2, i*2 + 2)
            val toInt = substring.toInt(16)

            temp[i]=toInt.toByte()
        }
        return temp;
    }

    fun fromByteArray2HexString(data:ByteArray):String{
        val stringBuilder = StringBuilder()
        for (i in 0 until data.size){
            var toInt = data[i].toInt()
            if(toInt<0) {
                toInt += 256
            }
            var s = toInt.toString(16)
            System.out.println(s)
            if(s.length==1){
                s= "0$s";
            }
            stringBuilder.append(s)
        }
        return stringBuilder.toString()
    }

    fun flipByteArray(byteArray: ByteArray):ByteArray{
        val target = ByteArray(byteArray.size)

        for(i in byteArray.indices){
            target[i]=byteArray[byteArray.size-1-i]
        }
        return target
    }

    fun getNodeHexString(nodeAddress:Int):String{
        return String.format(Locale.getDefault(),"%04X",nodeAddress)
    }

}